/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 21 "pilot_y.y"

#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include "pilot.h"

extern int yylineno, cmd;
extern FILE *yyin;

#define NOMEM	"out of memory\n"
#define BADATOM	"internal error, bad type in atom\n"

#define NONSTD	"this operation is not supported in IEEE 1154-1991\n"
#define NONSTANDARD	if (pedantic) yyerror(NONSTD); else

#include "gencode.h"
/*
 * Hold the strings and substitutable IDs in a text part.  The reasoning
 * behind the dimension is that there can't hardly be more of these than
 * there are characters on a line.
 */
static part textparts[MAXSTR], *tp;

/*
 * Cons nodes for expression structures.  Similar logic here.
 */
static node nodes[MAXSTR], *new = nodes;

/*
 * Label storage for JUMPMATCH handling
 */
static int njumplabs;
static variable *jumplabs[MAXJUMPS];

node *atom(type, value, var)
/* make an expression node from a part value */
int	type;	/* type of new node */
int	value;	/* part to be encapulated */
variable	*var;
{
    /* get a node */
    if (new < nodes + MAXSTR)
	new++;
    else
	yyerror(NOMEM);

    switch(new->type = type)
    {
    case NUMERIC_IDENT:
	new->value.var = var;
	break;

    case NUMBER:
	new->value.number = value;
	break;

    case YES:	/* eval() or the compiler will munch these */
    case NO:
	break;

    default:
	yyerror(BADATOM);
	break;
    }

    return(new);
}

node *cons(op, left, right)
/* make a cons for a binary operation */
int	op;		/* opcode */
node	*left, *right;	/* child nodes */
{
    /* get a node */
    if (new < nodes + MAXSTR)
	new++;
    else
	yyerror(NOMEM);

    new->type = op;
    new->left = left;
    new->right = right;

    return(new);
}


#line 159 "grammar.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "grammar.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TYPE = 3,                       /* TYPE  */
  YYSYMBOL_ACCEPT = 4,                     /* ACCEPT  */
  YYSYMBOL_MATCH = 5,                      /* MATCH  */
  YYSYMBOL_JUMP = 6,                       /* JUMP  */
  YYSYMBOL_USE = 7,                        /* USE  */
  YYSYMBOL_COMPUTE = 8,                    /* COMPUTE  */
  YYSYMBOL_GRAPHIC = 9,                    /* GRAPHIC  */
  YYSYMBOL_KFILE = 10,                     /* KFILE  */
  YYSYMBOL_REMARK = 11,                    /* REMARK  */
  YYSYMBOL_END = 12,                       /* END  */
  YYSYMBOL_YES = 13,                       /* YES  */
  YYSYMBOL_NO = 14,                        /* NO  */
  YYSYMBOL_JUMPMATCH = 15,                 /* JUMPMATCH  */
  YYSYMBOL_TYPEH = 16,                     /* TYPEH  */
  YYSYMBOL_PROBLEM = 17,                   /* PROBLEM  */
  YYSYMBOL_PAUSE = 18,                     /* PAUSE  */
  YYSYMBOL_LINK = 19,                      /* LINK  */
  YYSYMBOL_CLEARHOME = 20,                 /* CLEARHOME  */
  YYSYMBOL_CURSADDR = 21,                  /* CURSADDR  */
  YYSYMBOL_CLEARLINE = 22,                 /* CLEARLINE  */
  YYSYMBOL_CLEAREND = 23,                  /* CLEAREND  */
  YYSYMBOL_SYSTEM = 24,                    /* SYSTEM  */
  YYSYMBOL_NUMBER = 25,                    /* NUMBER  */
  YYSYMBOL_CHAR = 26,                      /* CHAR  */
  YYSYMBOL_SPECIAL = 27,                   /* SPECIAL  */
  YYSYMBOL_STRING = 28,                    /* STRING  */
  YYSYMBOL_ALLOC = 29,                     /* ALLOC  */
  YYSYMBOL_NUMERIC_IDENT = 30,             /* NUMERIC_IDENT  */
  YYSYMBOL_STRING_IDENT = 31,              /* STRING_IDENT  */
  YYSYMBOL_LABEL = 32,                     /* LABEL  */
  YYSYMBOL_NEWLINE = 33,                   /* NEWLINE  */
  YYSYMBOL_COLON = 34,                     /* COLON  */
  YYSYMBOL_35_ = 35,                       /* ':'  */
  YYSYMBOL_LPAREN = 36,                    /* LPAREN  */
  YYSYMBOL_37_ = 37,                       /* ')'  */
  YYSYMBOL_RPAREN = 38,                    /* RPAREN  */
  YYSYMBOL_39_ = 39,                       /* '('  */
  YYSYMBOL_PLUS = 40,                      /* PLUS  */
  YYSYMBOL_41_ = 41,                       /* '+'  */
  YYSYMBOL_MINUS = 42,                     /* MINUS  */
  YYSYMBOL_43_ = 43,                       /* '-'  */
  YYSYMBOL_MULTIPLY = 44,                  /* MULTIPLY  */
  YYSYMBOL_45_ = 45,                       /* '*'  */
  YYSYMBOL_DIVIDE = 46,                    /* DIVIDE  */
  YYSYMBOL_47_ = 47,                       /* '/'  */
  YYSYMBOL_MODULO = 48,                    /* MODULO  */
  YYSYMBOL_49_ = 49,                       /* '%'  */
  YYSYMBOL_EQUAL = 50,                     /* EQUAL  */
  YYSYMBOL_51_ = 51,                       /* '='  */
  YYSYMBOL_LESS = 52,                      /* LESS  */
  YYSYMBOL_53_ = 53,                       /* '<'  */
  YYSYMBOL_GREATER = 54,                   /* GREATER  */
  YYSYMBOL_55_ = 55,                       /* '>'  */
  YYSYMBOL_BANG = 56,                      /* BANG  */
  YYSYMBOL_57_ = 57,                       /* '!'  */
  YYSYMBOL_ORBAR = 58,                     /* ORBAR  */
  YYSYMBOL_59_ = 59,                       /* '|'  */
  YYSYMBOL_COMMA = 60,                     /* COMMA  */
  YYSYMBOL_61_ = 61,                       /* ','  */
  YYSYMBOL_NEQUAL = 62,                    /* NEQUAL  */
  YYSYMBOL_NOTGRT = 63,                    /* NOTGRT  */
  YYSYMBOL_NOTLESS = 64,                   /* NOTLESS  */
  YYSYMBOL_UMINUS = 65,                    /* UMINUS  */
  YYSYMBOL_ANDAND = 66,                    /* ANDAND  */
  YYSYMBOL_LEXERR = 67,                    /* LEXERR  */
  YYSYMBOL_YYACCEPT = 68,                  /* $accept  */
  YYSYMBOL_prog = 69,                      /* prog  */
  YYSYMBOL_statement = 70,                 /* statement  */
  YYSYMBOL_exec = 71,                      /* exec  */
  YYSYMBOL_lablist = 72,                   /* lablist  */
  YYSYMBOL_condition = 73,                 /* condition  */
  YYSYMBOL_yescond = 74,                   /* yescond  */
  YYSYMBOL_rel_exp = 75,                   /* rel_exp  */
  YYSYMBOL_expression = 76,                /* expression  */
  YYSYMBOL_term = 77,                      /* term  */
  YYSYMBOL_factor = 78,                    /* factor  */
  YYSYMBOL_text = 79                       /* text  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   173

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  68
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  12
/* YYNRULES -- Number of rules.  */
#define YYNRULES  68
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  150

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   307


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      33,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    57,     2,     2,     2,    49,     2,     2,
      39,    37,    45,    41,    61,    43,     2,    47,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    35,     2,
      53,    51,    55,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    59,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    34,    36,
      38,    40,    42,    44,    46,    48,    50,    52,    54,    56,
      58,    60,    62,    63,    64,    65,    66,    67
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   153,   153,   154,   156,   158,   164,   165,   166,   180,
     183,   185,   187,   190,   193,   195,   197,   199,   201,   204,
     206,   209,   211,   214,   217,   219,   222,   224,   226,   228,
     230,   232,   234,   236,   238,   240,   245,   247,   252,   253,
     254,   255,   258,   259,   262,   264,   265,   266,   267,   268,
     269,   272,   273,   274,   277,   278,   280,   281,   282,   286,
     287,   288,   292,   293,   295,   297,   299,   301,   303
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TYPE", "ACCEPT",
  "MATCH", "JUMP", "USE", "COMPUTE", "GRAPHIC", "KFILE", "REMARK", "END",
  "YES", "NO", "JUMPMATCH", "TYPEH", "PROBLEM", "PAUSE", "LINK",
  "CLEARHOME", "CURSADDR", "CLEARLINE", "CLEAREND", "SYSTEM", "NUMBER",
  "CHAR", "SPECIAL", "STRING", "ALLOC", "NUMERIC_IDENT", "STRING_IDENT",
  "LABEL", "NEWLINE", "COLON", "':'", "LPAREN", "')'", "RPAREN", "'('",
  "PLUS", "'+'", "MINUS", "'-'", "MULTIPLY", "'*'", "DIVIDE", "'/'",
  "MODULO", "'%'", "EQUAL", "'='", "LESS", "'<'", "GREATER", "'>'", "BANG",
  "'!'", "ORBAR", "'|'", "COMMA", "','", "NEQUAL", "NOTGRT", "NOTLESS",
  "UMINUS", "ANDAND", "LEXERR", "$accept", "prog", "statement", "exec",
  "lablist", "condition", "yescond", "rel_exp", "expression", "term",
  "factor", "text", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-66)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-45)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -66,    40,   -66,   -29,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
      14,    14,    14,    14,    97,   -66,   -21,   -66,   -66,   -66,
     -66,    46,     0,    -9,     7,    32,    42,    56,    63,   108,
     113,   114,   115,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   -66,   -66,   -66,    17,    54,   -16,    33,
      35,    -7,    47,   -66,    46,   -15,   -66,    -8,    48,    -5,
     -66,   -66,   -66,   138,    49,   -66,   -66,    54,   -66,   -66,
     139,   -66,   -66,   -66,   -66,   128,   -66,   -66,    54,    44,
     -22,    54,    54,   -16,   -16,   -16,   116,   129,   -66,   -66,
     116,   -66,   -66,   -66,   -66,   -66,   100,   101,   116,   116,
     116,   -66,   -66,   106,   116,   116,   -66,   116,   107,   116,
     -66,   -66,    54,    54,   -66,    54,   -66,   -66,   -66,   -66,
     -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,   -66,    54,
     -66,   137,   145,   -66,   -66,   -66,   -66,   116,   -66,   -66
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    38,    38,     6,     5,     0,     7,     4,    42,
      43,     0,     0,    39,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     8,     3,    61,    60,     0,     0,     0,
       0,    51,    54,    62,     0,    12,    62,     0,     0,     0,
      62,    62,    62,    25,     0,    62,    62,     0,    62,    31,
       0,    33,    34,    62,    60,     0,    55,    41,     0,     0,
       0,     0,     0,     0,     0,     0,     9,     0,    11,    10,
      13,    16,    15,    14,    18,    17,     0,     0,    21,    22,
      23,    24,    36,    26,    27,    28,    29,    30,     0,    35,
      59,    47,     0,     0,    45,     0,    46,    52,    53,    56,
      57,    58,    65,    66,    63,    64,    68,    67,    40,     0,
      62,     0,     0,    49,    48,    50,    20,    19,    37,    32
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -66,   -66,   -66,   147,   -66,   117,   -66,   109,   -57,    19,
     -56,   -65
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,    26,    27,   113,    32,    33,    59,    60,    61,
      62,    96
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      85,   100,    86,    55,    28,   108,   109,   110,    84,    55,
     114,   115,    54,   117,    84,    98,    99,    57,   119,   101,
     116,    58,   102,    57,   103,   106,   107,    29,    30,   125,
      64,   121,   124,   126,    91,    63,    92,   129,   130,   131,
       2,     3,    65,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    31,   -44,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,   143,   144,    66,   145,    55,
      87,    55,    24,    25,    84,   147,    56,    67,   104,    55,
     105,   112,   146,    57,    84,    57,    88,    58,    89,    58,
      90,    68,    93,    57,    94,   122,    95,    58,    69,   123,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
     127,   128,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,   132,   133,    70,   134,   135,   136,   137,    71,    72,
      73,   139,   140,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,   111,   118,   120,   138,   141,   142,   148,
     149,    53,     0,    97
};

static const yytype_int16 yycheck[] =
{
      57,    66,    58,    25,    33,    70,    71,    72,    30,    25,
      75,    76,    33,    78,    30,    30,    31,    39,    83,    27,
      77,    43,    30,    39,    32,    30,    31,    13,    14,    51,
      39,    88,    89,    90,    41,    35,    43,    93,    94,    95,
       0,     1,    35,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    39,    37,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,   122,   123,    35,   125,    25,
      37,    25,    32,    33,    30,   140,    30,    35,    30,    25,
      32,    32,   139,    39,    30,    39,    51,    43,    53,    43,
      55,    35,    45,    39,    47,    51,    49,    43,    35,    55,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      91,    92,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    25,    26,    35,    28,    29,    30,    31,    35,    35,
      35,    51,    51,    35,    35,    35,    35,    35,    35,    35,
      35,    35,    35,    25,    25,    37,    37,    61,    61,    32,
      25,    24,    -1,    64
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    69,     0,     1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    32,    33,    70,    71,    33,    13,
      14,    39,    73,    74,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    71,    33,    25,    30,    39,    43,    75,
      76,    77,    78,    35,    39,    35,    35,    35,    35,    35,
      35,    35,    35,    35,    35,    35,    35,    35,    35,    35,
      35,    35,    35,    35,    30,    76,    78,    37,    51,    53,
      55,    41,    43,    45,    47,    49,    79,    75,    30,    31,
      79,    27,    30,    32,    30,    32,    30,    31,    79,    79,
      79,    25,    32,    72,    79,    79,    76,    79,    25,    79,
      37,    76,    51,    55,    76,    51,    76,    77,    77,    78,
      78,    78,    25,    26,    28,    29,    30,    31,    37,    51,
      51,    61,    61,    76,    76,    76,    76,    79,    32,    25
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    68,    69,    69,    69,    69,    70,    70,    70,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
      71,    71,    71,    71,    71,    71,    72,    72,    73,    73,
      73,    73,    74,    74,    75,    75,    75,    75,    75,    75,
      75,    76,    76,    76,    77,    77,    77,    77,    77,    78,
      78,    78,    79,    79,    79,    79,    79,    79,    79
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     3,     2,     1,     1,     2,     4,
       4,     4,     3,     4,     4,     4,     4,     4,     4,     6,
       6,     4,     4,     4,     4,     3,     4,     4,     4,     4,
       4,     3,     6,     3,     3,     4,     1,     3,     0,     1,
       4,     3,     1,     1,     1,     3,     3,     3,     4,     4,
       4,     1,     3,     3,     1,     2,     3,     3,     3,     3,
       1,     1,     0,     2,     2,     2,     2,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* prog: prog statement NEWLINE  */
#line 155 "pilot_y.y"
                {eolhook(); new = nodes;}
#line 1322 "grammar.c"
    break;

  case 4: /* prog: prog error NEWLINE  */
#line 157 "pilot_y.y"
                {yyerrok;}
#line 1328 "grammar.c"
    break;

  case 6: /* statement: LABEL  */
#line 164 "pilot_y.y"
                                        {gen_label((yyvsp[0].var));}
#line 1334 "grammar.c"
    break;

  case 8: /* statement: LABEL exec  */
#line 166 "pilot_y.y"
                                        {gen_label((yyvsp[-1].var));}
#line 1340 "grammar.c"
    break;

  case 9: /* exec: TYPE condition ':' text  */
#line 181 "pilot_y.y"
                {gen_type((yyvsp[-2].node), textparts, tp - textparts);}
#line 1346 "grammar.c"
    break;

  case 10: /* exec: ACCEPT condition ':' STRING_IDENT  */
#line 184 "pilot_y.y"
                {gen_accept((yyvsp[-2].node), (yyvsp[0].var), STRING_IDENT);}
#line 1352 "grammar.c"
    break;

  case 11: /* exec: ACCEPT condition ':' NUMERIC_IDENT  */
#line 186 "pilot_y.y"
                {gen_accept((yyvsp[-2].node), (yyvsp[0].var), NUMERIC_IDENT);}
#line 1358 "grammar.c"
    break;

  case 12: /* exec: ACCEPT condition ':'  */
#line 188 "pilot_y.y"
                {gen_accept((yyvsp[-1].node), (variable *)NULL, 0);}
#line 1364 "grammar.c"
    break;

  case 13: /* exec: MATCH condition ':' text  */
#line 191 "pilot_y.y"
                {gen_match((yyvsp[-2].node), textparts, tp - textparts);}
#line 1370 "grammar.c"
    break;

  case 14: /* exec: JUMP condition ':' LABEL  */
#line 194 "pilot_y.y"
                {gen_jump((yyvsp[-2].node), (yyvsp[0].var), LABEL);}
#line 1376 "grammar.c"
    break;

  case 15: /* exec: JUMP condition ':' NUMERIC_IDENT  */
#line 196 "pilot_y.y"
                {NONSTANDARD {(yyvsp[0].var)->type = LABEL; gen_jump((yyvsp[-2].node), (yyvsp[0].var), LABEL);}}
#line 1382 "grammar.c"
    break;

  case 16: /* exec: JUMP condition ':' SPECIAL  */
#line 198 "pilot_y.y"
                {gen_jump((yyvsp[-2].node), (variable *)NULL, (yyvsp[0].number));}
#line 1388 "grammar.c"
    break;

  case 17: /* exec: USE condition ':' LABEL  */
#line 200 "pilot_y.y"
                {gen_use((yyvsp[-2].node), (yyvsp[0].var));}
#line 1394 "grammar.c"
    break;

  case 18: /* exec: USE condition ':' NUMERIC_IDENT  */
#line 202 "pilot_y.y"
                {NONSTANDARD {(yyvsp[0].var)->type = LABEL; gen_use((yyvsp[-2].node), (yyvsp[0].var));}}
#line 1400 "grammar.c"
    break;

  case 19: /* exec: COMPUTE condition ':' STRING_IDENT '=' text  */
#line 205 "pilot_y.y"
                {gen_compute((yyvsp[-4].node), (yyvsp[-2].var), (node *)NULL, textparts, tp - textparts);}
#line 1406 "grammar.c"
    break;

  case 20: /* exec: COMPUTE condition ':' NUMERIC_IDENT '=' expression  */
#line 207 "pilot_y.y"
                {gen_compute((yyvsp[-4].node), (yyvsp[-2].var), (yyvsp[0].node), (part *)NULL, 0);}
#line 1412 "grammar.c"
    break;

  case 21: /* exec: GRAPHIC condition ':' text  */
#line 210 "pilot_y.y"
                {gen_graphic((yyvsp[-2].node), textparts, tp - textparts);}
#line 1418 "grammar.c"
    break;

  case 22: /* exec: KFILE condition ':' text  */
#line 212 "pilot_y.y"
                {gen_file((yyvsp[-2].node), textparts, tp - textparts);}
#line 1424 "grammar.c"
    break;

  case 24: /* exec: END condition ':' NUMBER  */
#line 218 "pilot_y.y"
                {NONSTANDARD gen_end((yyvsp[-2].node), (yyvsp[0].number));}
#line 1430 "grammar.c"
    break;

  case 25: /* exec: END condition ':'  */
#line 220 "pilot_y.y"
                {gen_end((yyvsp[-1].node), 0);}
#line 1436 "grammar.c"
    break;

  case 26: /* exec: JUMPMATCH condition ':' lablist  */
#line 223 "pilot_y.y"
                {NONSTANDARD gen_jumpmatch((yyvsp[-2].node), njumplabs, jumplabs);}
#line 1442 "grammar.c"
    break;

  case 27: /* exec: TYPEH condition ':' text  */
#line 225 "pilot_y.y"
                {NONSTANDARD gen_typeh((yyvsp[-2].node), textparts, tp - textparts);}
#line 1448 "grammar.c"
    break;

  case 28: /* exec: PROBLEM condition ':' text  */
#line 227 "pilot_y.y"
                {NONSTANDARD gen_problem((yyvsp[-2].node), textparts, tp - textparts);}
#line 1454 "grammar.c"
    break;

  case 29: /* exec: PAUSE condition ':' expression  */
#line 229 "pilot_y.y"
                {NONSTANDARD gen_pause((yyvsp[-2].node), (yyvsp[0].node));}
#line 1460 "grammar.c"
    break;

  case 30: /* exec: LINK condition ':' text  */
#line 231 "pilot_y.y"
                {NONSTANDARD gen_link((yyvsp[-2].node), textparts, tp - textparts);}
#line 1466 "grammar.c"
    break;

  case 31: /* exec: CLEARHOME condition ':'  */
#line 233 "pilot_y.y"
                {NONSTANDARD gen_clearhome((yyvsp[-1].node));}
#line 1472 "grammar.c"
    break;

  case 32: /* exec: CURSADDR condition ':' NUMBER ',' NUMBER  */
#line 235 "pilot_y.y"
                {NONSTANDARD gen_cursaddr((yyvsp[-4].node), (yyvsp[-2].number), (yyvsp[0].number));}
#line 1478 "grammar.c"
    break;

  case 33: /* exec: CLEARLINE condition ':'  */
#line 237 "pilot_y.y"
                {NONSTANDARD gen_clearline((yyvsp[-1].node));}
#line 1484 "grammar.c"
    break;

  case 34: /* exec: CLEAREND condition ':'  */
#line 239 "pilot_y.y"
                {NONSTANDARD gen_clearend((yyvsp[-1].node));}
#line 1490 "grammar.c"
    break;

  case 35: /* exec: SYSTEM condition ':' text  */
#line 241 "pilot_y.y"
                {NONSTANDARD gen_system((yyvsp[-2].node), textparts, tp - textparts);}
#line 1496 "grammar.c"
    break;

  case 36: /* lablist: LABEL  */
#line 246 "pilot_y.y"
                {njumplabs = 0; jumplabs[njumplabs++] = (yyvsp[0].var);}
#line 1502 "grammar.c"
    break;

  case 37: /* lablist: lablist ',' LABEL  */
#line 248 "pilot_y.y"
                {jumplabs[njumplabs++] = (yyvsp[0].var);}
#line 1508 "grammar.c"
    break;

  case 38: /* condition: %empty  */
#line 252 "pilot_y.y"
                                                {(yyval.node) = (node *)NULL;}
#line 1514 "grammar.c"
    break;

  case 39: /* condition: yescond  */
#line 253 "pilot_y.y"
                                                {(yyval.node) = (yyvsp[0].node);}
#line 1520 "grammar.c"
    break;

  case 40: /* condition: yescond '(' rel_exp ')'  */
#line 254 "pilot_y.y"
                                                {(yyval.node) = cons(ANDAND, (yyvsp[-3].node), (yyvsp[-1].node));}
#line 1526 "grammar.c"
    break;

  case 41: /* condition: '(' rel_exp ')'  */
#line 255 "pilot_y.y"
                                                {(yyval.node) = (yyvsp[-1].node);}
#line 1532 "grammar.c"
    break;

  case 42: /* yescond: YES  */
#line 258 "pilot_y.y"
                                {(yyval.node) = atom(YES, 0, (variable *)NULL);}
#line 1538 "grammar.c"
    break;

  case 43: /* yescond: NO  */
#line 259 "pilot_y.y"
                                {(yyval.node) = atom(NO, 0, (variable *)NULL);}
#line 1544 "grammar.c"
    break;

  case 44: /* rel_exp: NUMERIC_IDENT  */
#line 263 "pilot_y.y"
                {(yyval.node) = atom(NUMERIC_IDENT, 0, (yyvsp[0].var));}
#line 1550 "grammar.c"
    break;

  case 45: /* rel_exp: expression '<' expression  */
#line 264 "pilot_y.y"
                                                {(yyval.node) = cons(LESS, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1556 "grammar.c"
    break;

  case 46: /* rel_exp: expression '>' expression  */
#line 265 "pilot_y.y"
                                                {(yyval.node) = cons(GREATER, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1562 "grammar.c"
    break;

  case 47: /* rel_exp: expression '=' expression  */
#line 266 "pilot_y.y"
                                                {(yyval.node) = cons(EQUAL, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1568 "grammar.c"
    break;

  case 48: /* rel_exp: expression '<' '>' expression  */
#line 267 "pilot_y.y"
                                                {(yyval.node) = cons(NEQUAL, (yyvsp[-3].node), (yyvsp[0].node));}
#line 1574 "grammar.c"
    break;

  case 49: /* rel_exp: expression '<' '=' expression  */
#line 268 "pilot_y.y"
                                                {(yyval.node) = cons(NOTGRT, (yyvsp[-3].node), (yyvsp[0].node));}
#line 1580 "grammar.c"
    break;

  case 50: /* rel_exp: expression '>' '=' expression  */
#line 269 "pilot_y.y"
                                                {(yyval.node) = cons(NOTLESS, (yyvsp[-3].node), (yyvsp[0].node));}
#line 1586 "grammar.c"
    break;

  case 51: /* expression: term  */
#line 272 "pilot_y.y"
                                                {(yyval.node) = (yyvsp[0].node);}
#line 1592 "grammar.c"
    break;

  case 52: /* expression: term '+' term  */
#line 273 "pilot_y.y"
                                                {(yyval.node) = cons(PLUS, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1598 "grammar.c"
    break;

  case 53: /* expression: term '-' term  */
#line 274 "pilot_y.y"
                                                {(yyval.node) = cons(MINUS, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1604 "grammar.c"
    break;

  case 54: /* term: factor  */
#line 277 "pilot_y.y"
                                        {(yyval.node) = (yyvsp[0].node);}
#line 1610 "grammar.c"
    break;

  case 55: /* term: '-' factor  */
#line 279 "pilot_y.y"
                {NONSTANDARD cons(UMINUS, 0, (yyvsp[0].node));}
#line 1616 "grammar.c"
    break;

  case 56: /* term: factor '*' factor  */
#line 280 "pilot_y.y"
                                        {(yyval.node) = cons(MULTIPLY, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1622 "grammar.c"
    break;

  case 57: /* term: factor '/' factor  */
#line 281 "pilot_y.y"
                                        {(yyval.node) = cons(DIVIDE, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1628 "grammar.c"
    break;

  case 58: /* term: factor '%' factor  */
#line 283 "pilot_y.y"
                {NONSTANDARD (yyval.node) = cons(MODULO, (yyvsp[-2].node), (yyvsp[0].node));}
#line 1634 "grammar.c"
    break;

  case 59: /* factor: '(' expression ')'  */
#line 286 "pilot_y.y"
                                {(yyval.node) = (yyvsp[-1].node);}
#line 1640 "grammar.c"
    break;

  case 60: /* factor: NUMERIC_IDENT  */
#line 287 "pilot_y.y"
                                {(yyval.node) = atom(NUMERIC_IDENT, 0, (yyvsp[0].var));}
#line 1646 "grammar.c"
    break;

  case 61: /* factor: NUMBER  */
#line 288 "pilot_y.y"
                                {(yyval.node) = atom(NUMBER, (yyvsp[0].number), (variable *)NULL);}
#line 1652 "grammar.c"
    break;

  case 62: /* text: %empty  */
#line 292 "pilot_y.y"
                {tp = textparts;}
#line 1658 "grammar.c"
    break;

  case 63: /* text: text STRING  */
#line 294 "pilot_y.y"
                {tp->type = STRING; tp->part.string = (yyvsp[0].string); tp++;}
#line 1664 "grammar.c"
    break;

  case 64: /* text: text ALLOC  */
#line 296 "pilot_y.y"
                {tp->type = ALLOC; tp->part.string = (yyvsp[0].string); tp++;}
#line 1670 "grammar.c"
    break;

  case 65: /* text: text NUMBER  */
#line 298 "pilot_y.y"
                {tp->type = NUMBER; tp->part.number = (yyvsp[0].number); tp++;}
#line 1676 "grammar.c"
    break;

  case 66: /* text: text CHAR  */
#line 300 "pilot_y.y"
                {tp->type = CHAR; tp->part.number = (yyvsp[0].number); tp++;}
#line 1682 "grammar.c"
    break;

  case 67: /* text: text STRING_IDENT  */
#line 302 "pilot_y.y"
                {tp->type = STRING_IDENT; tp->part.var = (yyvsp[0].var); tp++;}
#line 1688 "grammar.c"
    break;

  case 68: /* text: text NUMERIC_IDENT  */
#line 304 "pilot_y.y"
                {tp->type = NUMERIC_IDENT; tp->part.var = (yyvsp[0].var); tp++;}
#line 1694 "grammar.c"
    break;


#line 1698 "grammar.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 307 "pilot_y.y"


/* pilot.y ends here */
